const mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

mongoose.Promise = global.Promise;
mongoose.level = "F";

const tools = require('../tools/general');

const { ObjectId } = require('mongodb');

// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const SectorActivitiesSchema = new Schema({
  _id: {
    type: Number,
  },
  descr: {
    type: String,
  },
  idSectorActivities: {
    type: Number
  },
  icon: {
    type: String,
  },
  img: {
    type: String,
  },
  color: {
    type: String,
  },
  theme: {
    type: String,
  },
});

SectorActivitiesSchema.pre('save', async function (next) {
  if (this.isNew) {
    const myrec = await SectorActivities.findOne().limit(1).sort({ _id: -1 });
    if (!!myrec) {
      if (myrec._doc._id === 0)
        this._id = 1;
      else
        this._id = myrec._doc._id + 1;
    } else {
      this._id = 1;
    }
  }

  next();
});

SectorActivitiesSchema.statics.findAllIdApp = async function (idapp) {
  const SectorActivities = this;

  const query = [
    { $sort: { descr: 1 } }
  ];

  return await SectorActivities
    .aggregate(query)
    .then((arrrec) => {
      return arrrec
    })

};

SectorActivitiesSchema.statics.getFieldsForSearch = function () {
  return [{ field: 'descr', type: tools.FieldType.string }]
};

SectorActivitiesSchema.statics.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, 0, params);
};


const SectorActivities = mongoose.model('SectorActivities', SectorActivitiesSchema);

SectorActivities.createIndexes()
  .then(() => { })
  .catch((err) => { throw err; });


module.exports = { SectorActivities };
